from toloka.client.primitives.base import BaseTolokaObject
from toloka.client.task import Task
from toloka.client.task_suite import TaskSuite
from toloka.client.user_bonus import UserBonus
from typing import (
    Dict,
    Optional,
    List,
    Any
)


class FieldValidationError(BaseTolokaObject):
    """Error that contains information about an invalid field

    Attributes:
        code: error code string.
        message: error message.
        params: additional params.
    """

    def __init__(self, *, code: Optional[str] = None, message: Optional[str] = None, params: Optional[List[Any]] = None) -> None:
        """Method generated by attrs for class FieldValidationError.
        """
        ...

    _unexpected: Optional[Dict[str, Any]]
    code: Optional[str]
    message: Optional[str]
    params: Optional[List[Any]]

class TaskBatchCreateResult(BaseTolokaObject):
    """The list with the results of the tasks creation operation.

    Attributes:
        items: Object with created tasks.
        validation_errors: Object with errors in tasks. Returned if the parameter is used in the request skip_invalid_items=True.
    """

    def __init__(self, *, items: Optional[Dict[str, Task]] = None, validation_errors: Optional[Dict[str, Dict[str, FieldValidationError]]] = None) -> None:
        """Method generated by attrs for class TaskBatchCreateResult.
        """
        ...

    _unexpected: Optional[Dict[str, Any]]
    items: Optional[Dict[str, Task]]
    validation_errors: Optional[Dict[str, Dict[str, FieldValidationError]]]

class TaskSuiteBatchCreateResult(BaseTolokaObject):
    """The list with the results of the task suites creation operation.

    Attributes:
        items: Object with created task suites.
        validation_errors: Object with errors in task suites. Returned if the parameter is used in the request skip_invalid_items=True.
    """

    def __init__(self, *, items: Optional[Dict[str, TaskSuite]] = None, validation_errors: Optional[Dict[str, Dict[str, FieldValidationError]]] = None) -> None:
        """Method generated by attrs for class TaskSuiteBatchCreateResult.
        """
        ...

    _unexpected: Optional[Dict[str, Any]]
    items: Optional[Dict[str, TaskSuite]]
    validation_errors: Optional[Dict[str, Dict[str, FieldValidationError]]]

class UserBonusBatchCreateResult(BaseTolokaObject):
    """The list with the results of the user bonuses creation operation.

    Attributes:
        items: Object with information about issued bonuses.
        validation_errors: Object with validation errors. Returned if the parameter is used in the request skip_invalid_items=True.
    """

    def __init__(self, *, items: Optional[Dict[str, UserBonus]] = None, validation_errors: Optional[Dict[str, Dict[str, FieldValidationError]]] = None) -> None:
        """Method generated by attrs for class UserBonusBatchCreateResult.
        """
        ...

    _unexpected: Optional[Dict[str, Any]]
    items: Optional[Dict[str, UserBonus]]
    validation_errors: Optional[Dict[str, Dict[str, FieldValidationError]]]

